/**************************************************************************
*   Copyright (C) 2009 by Thomas Lübking                                  *
*   thomas.luebking@web.de                                                *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#ifndef BECLOCK_ADAPTOR_H
#define BECLOCK_ADAPTOR_H

#include <QtDBus/QDBusAbstractAdaptor>
#include "beclock.h"

namespace KWin
{
class BeClockAdaptor : public QDBusAbstractAdaptor
{
   Q_OBJECT
   Q_CLASSINFO("D-Bus Interface", "org.kde.kwin")

private:
    BeClock *myClock;

public:
    BeClockAdaptor(BeClock *clock) : QDBusAbstractAdaptor(clock), myClock(clock) { }

public slots:
    Q_NOREPLY void countdown(uint secs) { myClock->countdown(secs); }
    Q_NOREPLY void countdown(uint mins, uint secs) { myClock->countdown(60*mins+secs); }
    Q_NOREPLY void countdown(uint hrs, uint mins, uint secs) { myClock->countdown(3600*hrs + 60*mins + secs); }
    Q_NOREPLY void getAttention(int n) { myClock->getAttention(n); }
};
}
#endif //BECLOCK_ADAPTOR_H
