/********************************************************************
 KWin - the KDE window manager
 This file is part of the KDE project.

Copyright (C) 2010 Thomas Lübking <thomas.luebking@web.de>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*********************************************************************/

#ifndef BE_FADED_H
#define BE_FADED_H

#include <kwinanimationeffect.h>

namespace KWin
{

class BeFaded : public AnimationEffect
{
    Q_OBJECT
public:
    BeFaded();
    void reconfigure(ReconfigureFlags);
private slots:
    void stackingOrderChanged();
    void tabBoxAdded();
    void tabBoxClosed();
    void windowAdded(KWin::EffectWindow*);
    void windowUnminimized(KWin::EffectWindow*);
    void windowDeleted(KWin::EffectWindow*);

protected:
    void animationEnded(EffectWindow *w, Attribute a, uint meta);

private:
    void windowRaised( EffectWindow *w );
    EffectWindow *upmost( const EffectWindowList &stack );
    EffectWindow *theJustMapped, *theUpmostWindow;
    bool checkedUpMost;
    EffectWindowList theOldStackingOrder;
    int m_tabboxActive;
};

} // namespace

#endif
